import Qt 4.7
import "imports/colibri"
import "imports/XAComponents"
import "AICalendarPickerJS.js" as XACalJS

Rectangle {
    id: aiCalendarPicker

    color: "transparent"

    property int pickerDirection : qtPickerDirection;
    property int pickerTopSpacer : (pickerDirection == 2) ? 16 : 0
    property int pickerBottomSpacer : (pickerDirection == 2) ? 0 : 16

    property string windowGotFocus : qtWindowGotFocus
    property string sqlDTS1 : qtSqlDTS1
    property string sqlDTS2 : qtSqlDTS2
    property string sqlDTS3 : qtSqlDTS3

    property string currentMonth : "initM"
    property string currentYear : "initY"

    property int theDay : 3
    property int theMonth : 7
    property int theYear : 2010

    property int displayMonth : 7
    property int displayYear : 2010

    property bool enabled: true

    property string theTime: "00:00:00"

//    onSqlDTS1Changed: console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX onsqlDTS1Changed VALUE CHANGED:" << sqlDTS1);

    function onPresetValuesCompleted() {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX VALUES LOADED.");
//        console.debug(qtSqlDTS1 + " / " + sqlDTS1)
//        console.debug(qtSqlDTS2 + " / " + sqlDTS2)
//        console.debug(qtSqlDTS3 + " / " + sqlDTS3)

        sqlDTS1 = qtSqlDTS1;
        sqlDTS2 = qtSqlDTS2;
        sqlDTS3 = qtSqlDTS3;
    }

    function selectNextReviewDate() {
        //console.debug("QML++ selectNextReviewDate")

        segmentGrid.currentIndex = 0
        XACalJS.updatePickerByIndexSelected()
    }

    function selectStartDate() {
        //console.debug("QML++ selectStartDate")

        segmentGrid.currentIndex = 1
        XACalJS.updatePickerByIndexSelected()
    }

    function selectDueDate() {
        //console.debug("QML++ selectDueDate")

        segmentGrid.currentIndex = 2
        XACalJS.updatePickerByIndexSelected()
    }

    Component.onCompleted: {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Component.onCompleted.");
        XACalJS.buildClock();

        segmentGrid.currentIndex = 0
    }

    function doOp(opcode, operation) {
        XACalJS.doOp(opcode, operation);
    }

    //
    // close tabs for different picker directions
    //

    Rectangle {
        id: closeTabTop
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 2)

        Image {
            anchors.left: parent.left
            anchors.top: parent.top
            source: "imports/XAComponents/pics/PreviewIconCalendarPopupButtonPressed16px.png"
        }

        MouseArea {
            id: closeTabTopMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    Rectangle {
        id: closeTabBottom
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 1)

        Image {
            anchors.left: parent.left
            anchors.bottom: parent.bottom
            source: "imports/XAComponents/pics/PreviewIconCalendarPopupButtonPressed16px.png"
        }

        MouseArea {
            id: closeTabBottomMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    //
    // window content
    //

    Item {
        id: contentArea
        anchors.fill: parent
        anchors.topMargin: pickerTopSpacer
        anchors.bottomMargin: pickerBottomSpacer

//        onFocusChanged: console.debug("AICalendarPicker: focus changed.")

        ListModel {
            id: dateSelectionModel
            //            ListElement { name: "Next Review" }
            //            ListElement { name: "Start Date" }
            //            ListElement { name: "Due Date" }

            ListElement { name: "Next Review"; }
            ListElement { name: "Start Date" }
            ListElement { name: "Due Date" }

            function i18n(index) {
                if (i18n["text"] === undefined) {
                    i18n.text = [
                                qsTr("Next Review"),
                                qsTr("Start Date"),
                                qsTr("Due Date")
                            ]
                }
                return i18n.text[index]
            }
        }

        Item {
            id: repeatSegmentControl
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.bottom: parent.bottom

            Rectangle {
                id: repeatSegmentControlRect
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                //            anchors.topMargin: pickerTopSpacer
                height: 25
                clip: true
                color: "black"

                GridView {
                    id: segmentGrid
                    anchors.fill: parent
                    anchors.topMargin: 1
                    anchors.leftMargin: 2
                    anchors.rightMargin: 2

                    cellWidth: (aiCalendarPicker.width-5) / 3; cellHeight: parent.height - 4

                    model: dateSelectionModel
                    delegate: segmentCellDelegate
                    highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}

                    onVisibleChanged: {
                        if (visible) {
                            segmentGrid.currentIndex = repeaterTypeSegmentSelected;
                        }
                    }

                    onCurrentIndexChanged: {
//                        console.debug("segmentGrid onCurrentIndexChanged")

                        XACalJS.updatePickerByIndexSelected();
                    }

                    Component {
                        id: segmentCellDelegate

                        Item {
                            id: segmentCellDelegateItem
                            width: segmentGrid.cellWidth; height: segmentGrid.cellHeight

                            MouseArea {
                                anchors.fill: parent
                                onClicked: {
                                    segmentGrid.currentIndex = index;
                                }
                            }

//                            Column {
                            Item {
                                id: segmentCellDelegateColumn
                                anchors.fill: parent
                                anchors.topMargin: 2
                                anchors.bottomMargin: 2
                                //                            anchors.left: parent.left
                                anchors.leftMargin: 1
                                //                            anchors.right: parent.right
                                anchors.rightMargin: 1

                                Text {
                                    //text: name;
                                    text: segmentGrid.model.i18n(index);
                                    font.family: "Arial";
                                    font.bold: true;
                                    //font.pointSize: 11;
                                    font.pixelSize: 11
                                    anchors.top: parent.top
                                    anchors.topMargin: 4
                                    anchors.horizontalCenter: parent.horizontalCenter
                                    color: "white";
                                    smooth: true;
                                }
                            }
                        }
                    }
                }
            }
        }

        Rectangle {
            id: contentRectangle
            anchors.fill: parent
            anchors.topMargin: 25

            gradient: Gradient {
                GradientStop { position: 0; color: "#222222" }
                GradientStop { position: 0.5; color: "#3f3b3c" }
                GradientStop { position: 1; color: "#222222" }
            }

            radius: 0
            smooth: true

            Item {
                id: calendarBox
                anchors.left: parent.left
                anchors.leftMargin: 6
                width: 180
                height: 170
                anchors.top: parent.top
                anchors.topMargin: 10

                //
                // calendar header / month up and down boxes
                //

                Item {
                    id: dateNavBox
                    anchors.left: parent.left
                    anchors.right: parent.right
                    anchors.top: parent.top
                    height: 24
                    anchors.leftMargin: 10; anchors.rightMargin: 10

                    Item {
                        id: dateNavLeft
                        anchors.left: parent.left
                        y: 4
                        width: 12
                        height: 12

                        Image {
                            id: dateNavLeftImage
                            anchors.fill: parent
                            smooth: true

                            source: "imports/XAComponents/pics/CalendarBackButton12px.png"
                        }

                        MouseArea {
                            id: dateNavLeftMouseArea
                            anchors.fill: parent

                            onClicked: {
//                                if (theMonth > 1) theMonth--
//                                else {
//                                    theYear--;
//                                    theMonth = 12;
//                                }
//                                console.debug("Month:" + theMonth + " Year:" + theYear)
//                                XACalJS.loadSelectedMonth();

                                if (displayMonth > 1) displayMonth--
                                else {
                                    displayYear--;
                                    displayMonth = 12;
                                }
//                                console.debug("Month:" + theMonth + " Year:" + theYear)
                                XACalJS.loadMonth(displayMonth, displayYear);
                            }
                        }
                    }


                    Item {
                        id: dateNavToday
                        anchors.left: parent.left
                        anchors.leftMargin: 14
                        y: 4
                        width: 12
                        height: 12

                        Image {
                            id: dateNavTodayImage
                            anchors.fill: parent
                            smooth: true

                            source: "imports/XAComponents/pics/CalendarTodayButton12px.png"
                        }

                        MouseArea {
                            id: dateNavTodayMouseArea
                            anchors.fill: parent

                            onClicked: XACalJS.loadNow();
                        }
                    }

                    Item {
                        id: dateNavRight
                        anchors.left: parent.left
                        anchors.leftMargin: 28
                        y: 4
                        width: 12
                        height: 12

                        Image {
                            id: dateNavRightImage
                            anchors.fill: parent
                            smooth: true

                            source: "imports/XAComponents/pics/CalendarNextButton12px.png"
                        }

                        MouseArea {
                            id: dateNavRightMouseArea
                            anchors.fill: parent

                            onClicked: {
//                                if (theMonth < 12) theMonth++
//                                else {
//                                    theYear++;
//                                    theMonth = 1;
//                                }
//                                console.debug("Month:" + theMonth + " Year:" + theYear)
//                                XACalJS.loadSelectedMonth();

                                if (displayMonth < 12) displayMonth++
                                else {
                                    displayYear++;
                                    displayMonth = 1;
                                }
//                                console.debug("Month:" + theMonth + " Year:" + theYear)
                                XACalJS.loadMonth(displayMonth, displayYear);
                            }
                        }
                    }

                    Text {
                        id: dateNavLabel
                        anchors.right: parent.right
                        anchors.left: parent.left
                        anchors.leftMargin: 40
                        anchors.top: parent.top
                        height: 20

                        color: "white"
                        text: currentMonth + " " + currentYear
                        font.family: "Arial"
                        font.pixelSize: 11
                        font.bold: true
                        horizontalAlignment: Text.AlignRight
                        verticalAlignment: Text.AlignVCenter
                    }
                }

                Column {
                    id: box; spacing: 8
                    anchors { fill: parent; topMargin: 20; bottomMargin: 0; leftMargin: 6; rightMargin: 6 }

                    Column {
                        id: column; spacing: 2
                        //anchors { fill: parent }

                        property real h: ((box.height) / 6) - ((spacing * (6 - 1)) / 6) -1
                        property real w: (box.width / 4) - ((spacing * (4 - 1)) / 4)

                        Grid {
                            id: grid; rows: 7; columns: 7; spacing: 0
                            //anchors { fill: parent }

                            property real w: (box.width / columns) - ((spacing * (columns - 1)) / columns)

                            XAQMLDatePickerButton { id: xlwd1; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd2; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd3; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd4; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd5; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd6; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }
                            XAQMLDatePickerButton { id: xlwd7; width: grid.w; height: column.h; font.bold:true; enabled: false; buttonMode: false }

                            XAQMLDatePickerButton { id: xld01; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld02; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld03; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld04; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld05; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld06; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld07; width: grid.w; height: column.h; }

                            XAQMLDatePickerButton { id: xld11; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld12; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld13; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld14; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld15; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld16; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld17; width: grid.w; height: column.h; }

                            XAQMLDatePickerButton { id: xld21; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld22; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld23; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld24; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld25; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld26; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld27; width: grid.w; height: column.h; }

                            XAQMLDatePickerButton { id: xld31; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld32; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld33; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld34; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld35; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld36; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld37; width: grid.w; height: column.h; }

                            XAQMLDatePickerButton { id: xld41; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld42; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld43; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld44; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld45; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld46; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld47; width: grid.w; height: column.h; }

                            XAQMLDatePickerButton { id: xld51; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld52; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld53; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld54; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld55; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld56; width: grid.w; height: column.h; }
                            XAQMLDatePickerButton { id: xld57; width: grid.w; height: column.h; }
                        }
                    }
                }

            }

            XAVDivisionLine {
                anchors.top: parent.top
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 24
                anchors.left:  parent.left
                anchors.leftMargin: 198
            }

            Rectangle {
                id: timePickerFrame
                anchors.right: parent.right
                anchors.rightMargin: 5
                width: 180
                height: 170
                anchors.top: parent.top
                anchors.topMargin: 10

                color: "transparent"

                Image {
                    id: timePickerOnOffSwitch
                    anchors.top: parent.top
                    anchors.left: parent.left
                    anchors.leftMargin: (grid.w * 3 - 30)
                    width: 60
                    height: 28

                    source: (timePicker.enabled) ? "imports/XAComponents/pics/XASwitchOn.png" : "imports/XAComponents/pics/XASwitchOff.png"

                    MouseArea {
                        id: timePickerOnOffSwitchMA
                        anchors.fill: parent

                        onClicked: {
                            timePicker.enabled = !timePicker.enabled
                            XACalJS.switchTimeSelection(timePicker.enabled)
                        }
                    }
                }


                Rectangle {
                    id: timePicker
                    anchors.fill: parent
                    anchors.topMargin: 30
                    color: "transparent"

                    property bool enabled: true

                    Grid {
                        id: timePickerGridAM; rows: 2; columns: 6; spacing: 0
                        anchors { fill: parent }
                        height: grid.w * 2

                        XAQMLDatePickerButton { id: xlt01; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt02; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt03; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt04; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt05; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt06; width: grid.w; height: column.h; }

                        XAQMLDatePickerButton { id: xlt11; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt12; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt13; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt14; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt15; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt16; width: grid.w; height: column.h; }
                    }

                    Text {
                        id: timePickerAMLabel
                        anchors.right: parent.right
                        anchors.rightMargin: 5
                        anchors.top: timePickerGridAM.top
                        width: 25
                        height: grid.w * 2

                        color: "white"
                        font.family: "Arial"
                        font.pixelSize: 11
                        font.bold: false
                        horizontalAlignment: Text.AlignLeft
                        verticalAlignment: Text.AlignVCenter

                        text: "AM"
                    }

                    Grid {
                        id: timePickerGridPM; rows: 2; columns: 6; spacing: 0
                        anchors { fill: parent; topMargin: grid.w * 2 }
                        height: grid.w * 2

                        XAQMLDatePickerButton { id: xlt21; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt22; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt23; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt24; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt25; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt26; width: grid.w; height: column.h; }

                        XAQMLDatePickerButton { id: xlt31; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt32; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt33; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt34; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt35; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlt36; width: grid.w; height: column.h; }
                    }

                    Text {
                        id: timePickerPMLabel
                        anchors.right: parent.right
                        anchors.rightMargin: 5
                        anchors.top: timePickerGridPM.top
                        width: 25
                        height: grid.w * 2

                        color: "white"
                        font.family: "Arial"
                        font.pixelSize: 11
                        font.bold: false
                        horizontalAlignment: Text.AlignLeft
                        verticalAlignment: Text.AlignVCenter

                        text: "PM"
                    }

                    Grid {
                        id: timePickerGridMinutes; rows: 2; columns: 6; spacing: 0
                        anchors { fill: parent; topMargin: grid.w * 4 }
                        height: grid.w * 2

                        XAQMLDatePickerButton { id: xlm01; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm02; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm03; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm04; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm05; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm06; width: grid.w; height: column.h; }

                        XAQMLDatePickerButton { id: xlm11; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm12; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm13; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm14; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm15; width: grid.w; height: column.h; }
                        XAQMLDatePickerButton { id: xlm16; width: grid.w; height: column.h; }
                    }

                    Text {
                        id: timePickerMinutesLabel
                        anchors.right: parent.right
                        anchors.rightMargin: 5
                        anchors.top: timePickerGridMinutes.top
                        width: 25
                        height: grid.w * 2

                        color: "white"
                        font.family: "Arial"
                        font.pixelSize: 11
                        font.bold: false
                        horizontalAlignment: Text.AlignLeft
                        verticalAlignment: Text.AlignVCenter

                        text: "Min"
                    }
                }
            }
        }

        XAHDivisionLine {
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottomMargin: 23
        }

        Image {
            id: titlebarCloseImage
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            anchors.right: parent.right
            anchors.rightMargin: 3
            width: 19
            height: 18
            source: "imports/XAComponents/pics/PanelCloseButton14.png"

            MouseArea {
                id: titlebarCloseImageMouseArea
                anchors.fill: parent

                onClicked: {
                    XACalJS.dateDeselected();
                }
            }
        }

        Rectangle {
            id: timePickerFooter
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.leftMargin: 25
            anchors.right: parent.right
            anchors.rightMargin: 25
            height: 20

            color: "transparent"

            Text {
                id: footerLabel
                anchors.fill: parent

                color: "white"
                font.family: "Arial"
                font.pixelSize: 11
                font.bold: false
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
            }
        }
    }
//    }

}
