import Qt 4.7

Item {
    id: rectangle
    anchors.fill: parent

    property alias text: textField.text
    property string label: "untitled:"
    property int tabOrder: -1
    property bool editable: false

    signal textChanged()
    signal focusReceived()
    signal tab()
    signal backtab()

    function activateControl(cursorVisible) {
        var activedColor = "#222222"

        cursorVisible = (typeof cursorVisible == 'undefined') ? false : cursorVisible

        textField.cursorVisible = cursorVisible
        textFieldBorderRect.color = activedColor
        content.color = activedColor
    }

    function deactivateControl() {
        var deactivatedColor = "#00000000"

        textField.cursorVisible = false
        textFieldBorderRect.color = deactivatedColor
        content.color = deactivatedColor

        content.focus = false
    }

    function setFocus() {
        textField.focus = true
        rectangle.focusReceived()
    }

    Rectangle {
        id: content
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.right: parent.right
        height: 28
        color: "black"
        radius: 10
        smooth: true
        opacity: 1.0

        MouseArea {
            id: mouseArea

            anchors.fill: content
            onClicked: {
                textField.focus = true
                //textField.selectAll()
                //content.focusReceived()
                rectangle.focusReceived()
            }
        }

        Text {
            id: labelFieldShadow
            anchors.left: parent.left
            anchors.leftMargin: 28
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 80
            height: 20
            color: "#000000"
            text: rectangle.label
            font.pixelSize: 11
            font.bold: true
            smooth: true
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignRight
        }

        Text {
            id: labelField
            anchors.left: parent.left
            anchors.leftMargin: 28
            anchors.top: parent.top
            anchors.topMargin: 4
            width: 80
            height: 20
            color: "#ffffff"
            text: rectangle.label
            font.pixelSize: 11
            font.bold: true
            smooth: true
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignRight
        }

        Rectangle {
            id: textFieldBorderRect
            anchors.left: parent.left
            anchors.leftMargin: 115
            anchors.top: parent.top
            anchors.topMargin: 4
            width: 149
            height: 20
            color: "black"
            border.color: "white"
            border.width: 1


            TextInput {
                id: textField
                text: ""

                color: "#ffffff"
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: parent.left
                anchors.leftMargin: 2
                anchors.right: parent.right
                anchors.rightMargin: 2
                font.pixelSize: 11
                cursorVisible: false
                selectByMouse: true
                selectionColor: "lightblue"
                smooth: true
                focus: rectangle.focus
                //enabled: rectangle.editable

                onFocusChanged: {
                    if (focus) {
                        //textField.selectAll();
                        rectangle.focusReceived()
                    } else {
                        //textField.deselect();

                    }
                }

                onTextChanged: rectangle.textChanged()

                Keys.onTabPressed: rectangle.tab()
                Keys.onBacktabPressed: rectangle.backtab()
            }
        }
    }

}
