import Qt 4.7
import "../../imports/colibri"

Item {
    id: xaqmlDatePicker1
    width: 250
    height: 270

    //color: "#282828"

    property string rotateLeft: "\u2939"
    property string rotateRight: "\u2935"
    property string leftArrow: "\u2190"
    property string division : "\u00f7"
    property string multiplication : "\u00d7"
    property string squareRoot : "\u221a"
    property string plusminus : "\u00b1"

    property string currentMonth : "initM"
    property string currentYear : "initY"

    property int theDay : 3
    property int theMonth : 7
    property int theYear : 2010

    property bool enabled: true

    property string theTime: "00:00:00"

    signal dateSelected()

    function getCalendarDate() {
       var months = new Array(13);
       months[0]  = "January";
       months[1]  = "February";
       months[2]  = "March";
       months[3]  = "April";
       months[4]  = "May";
       months[5]  = "June";
       months[6]  = "July";
       months[7]  = "August";
       months[8]  = "September";
       months[9]  = "October";
       months[10] = "November";
       months[11] = "December";
       var now         = new Date();
       var monthnumber = now.getMonth();
       var monthname   = months[monthnumber];
       var monthday    = now.getDate();
       var year        = now.getYear();
       if(year < 2000) { year = year + 1900; }
       var dateString = monthname +
                        ' ' +
                        monthday +
                        ', ' +
                        year;
       return dateString;
    } // function getCalendarDate()

    function getClockTime() {
       var now    = new Date();
       var hour   = now.getHours();
       var minute = now.getMinutes();
       var second = now.getSeconds();

//       var ap = "AM";
//       if (hour   > 11) { ap = "PM";             }
//       if (hour   > 12) { hour = hour - 12;      }
//       if (hour   == 0) { hour = 12;             }

       if (hour   < 10) { hour   = "0" + hour;   }
       if (minute < 10) { minute = "0" + minute; }
       if (second < 10) { second = "0" + second; }
       //var timeString = hour + ':' + minute + ':' + second + " " + ap;
       var timeString = hour + ":" + minute + ":" + second;

       return timeString;
    } // function getClockTime()

    function buildCal(m, y){
        var mn=['January','February','March','April','May','June','July','August','September','October','November','December'];
        var dim=[31,0,31,30,31,30,31,31,30,31,30,31];

        var oD = new Date(y, m-1, 1); //DD replaced line to fix date bug when current day is 31st
        oD.od=oD.getDay()+1; //DD replaced line to fix date bug when current day is 31st

        var todaydate=new Date() //DD added
        var scanfortoday=(y==todaydate.getFullYear() && m==todaydate.getMonth()+1)? todaydate.getDate() : 0 //DD added

        var selectiondate=new Date(xaqmldatepicker.theYear, xaqmldatepicker.theMonth-1, xaqmldatepicker.theDay)
        var scanforselection = 0

        if (xaqmldatepicker.enabled) {
            scanforselection =(y==selectiondate.getFullYear() && m==selectiondate.getMonth()+1)? selectiondate.getDate() : 0 //DD added
        }

        dim[1]=(((oD.getFullYear()%100!=0)&&(oD.getFullYear()%4==0))||(oD.getFullYear()%400==0))?29:28;

        xaqmlDatePicker1.currentMonth = mn[m-1];
        xaqmlDatePicker1.currentYear = y

        xlwd1.operation = "Su"
        xlwd2.operation = "Mo"
        xlwd3.operation = "Tu"
        xlwd4.operation = "We"
        xlwd5.operation = "Th"
        xlwd6.operation = "Fr"
        xlwd7.operation = "Sa"

        var buttons = [xld01, xld02, xld03, xld04, xld05, xld06, xld07, xld11, xld12, xld13, xld14, xld15, xld16, xld17,
                       xld21, xld22, xld23, xld24, xld25, xld26, xld27, xld31, xld32, xld33, xld34, xld35, xld36, xld37,
                       xld41, xld42, xld43, xld44, xld45, xld46, xld47]

        var i
        for(i=1; i<=35; i++) {
            var x=((i-oD.od>=0)&&(i-oD.od<dim[m-1]))? i-oD.od+1 : '';

            //console.debug("next value:" + x + " selected:" + scanforselection + " today:" + scanfortoday)

            if (x != '') {
                buttons[i-1].operation = x
                buttons[i-1].enabled = true

                if (scanfortoday != 0 && x==scanfortoday) buttons[i-1].framed = true
                else buttons[i-1].framed = false

                if (scanforselection != 0 && x==scanforselection) buttons[i-1].selected = true
                else buttons[i-1].selected = false

            } else {
                buttons[i-1].operation = ""
                buttons[i-1].enabled = false
                buttons[i-1].selected = false
                buttons[i-1].framed = false
            }

        }

    }

    function loadNow() {
        var todaydate = new Date();

        theMonth = todaydate.getMonth()+1 //get current month (1-12)
        theYear = todaydate.getFullYear() //get current year
        theDay = todaydate.getDate() // get current date

        theTime = getClockTime()
        //timeInput.text = theTime

        loadSelectedMonth()
    }

    function loadSelectedMonth() {
        if (theMonth <= 12) buildCal(theMonth, theYear);
        else {
            xaqmlDatePicker1.enabled
            onOffBox.loadSettings()
        }
    }

    function loadSelectedTime() {
        console.debug("loadSelectedTime:" + theTime)
        console.debug("hours:" + theTime.substring(0,2))
        console.debug("minutes:" + theTime.substring(3,5))

        xaTimePicker.setHours(theTime.substring(0,2))
        xaTimePicker.setMinutes(theTime.substring(3,5))
    }

    function doOp(operation) {
        console.debug("doOp:" + operation)
        theDay = operation

        xaqmlDatePicker1.enabled = true
        onOffBox.loadSettings()

        //xaqmlDatePicker1.theTime = timeInput.text
        xaTimePicker.setHours(theTime.substring(0,2))
        xaTimePicker.setMinutes(theTime.substring(3,5))

        dateSelected()
    }

    onTheMonthChanged: loadSelectedMonth()
    onTheYearChanged: loadSelectedMonth()
    onTheDayChanged: loadSelectedMonth()
    onTheTimeChanged: loadSelectedTime()

    onEnabledChanged: onOffBox.loadSettings()

    Component.onCompleted: loadNow();

    Item {
        id: onOffBox
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        function setOn() {
            console.debug("set on")
            onOffSliderRect.anchors.leftMargin = 35
            //onOffRect.color = "blue"
            onOffRect.gradient = selectedEnabledGradient
        }

        function setOff() {
            console.debug("set off")
            onOffSliderRect.anchors.leftMargin = 0
            //onOffRect.color = "white"
            onOffRect.gradient = selectedDisabledGradient
        }

        function loadSettings() {
            if (xaqmlDatePicker1.enabled) { setOn(); xaTimePicker.enabled = true; }
            else { setOff(); xaTimePicker.enabled = false; }

            loadSelectedMonth();
        }

        Gradient {
            id: selectedEnabledGradient
            GradientStop { position: 0.0; color: "#2356b8" }
            GradientStop { position: 0.8; color: "#6396f8" }
            //GradientStop { position: 1.0; color: "white" }
            GradientStop { position: 1.0; color: "#6396f8" }
        }
        Gradient {
            id: selectedDisabledGradient
            GradientStop { position: 0.0; color: "#717171" }
            GradientStop { position: 0.8; color: "white" }
            //GradientStop { position: 1.0; color: "white" }
            GradientStop { position: 1.0; color: "white" }
        }

        Text {
            id: onOffBoxLabelShadow
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.topMargin: 6
            width: 120
            height: 18
            color: "black"
            text: "Enabled:"
            font.bold: true
            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
            smooth: true
        }

        Text {
            id: onOffBoxLabel
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 120
            height: 18
            color: "white"
            text: "Enabled:"
            font.bold: true
            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
            smooth: true
        }

        Rectangle {
            id: onOffRect
            anchors.left: parent.left
            anchors.leftMargin: 130
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 65
            height: 20
            //color: "blue"
            gradient: selectedEnabledGradient
            smooth: true
            radius: 3

            Text {
                id: onLabel
                anchors.left: parent.left
                anchors.top: parent.top
                anchors.right: parent.right
                anchors.rightMargin: 32
                height: 20
                color: "white"
                text: "ON"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: onMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOff()
                        xaqmlDatePicker1.enabled = false
                        dateSelected()
                    }
                }
            }
            Text {
                id: offLabel
                anchors.left: parent.left
                anchors.leftMargin: 32
                anchors.top: parent.top
                anchors.right: parent.right
                height: 20
                color: "black"
                text: "OFF"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: offMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOn()
                        xaqmlDatePicker1.enabled = true
                        dateSelected()
                    }
                }
            }

            Rectangle {
                id: onOffSliderRect
                anchors.left: parent.left
                anchors.top: parent.top
                width: 30
                height: 20
                color: "white"
                border.color: "#222222"
                border.width: 1
                smooth: true
                radius: 3

                Behavior on anchors.leftMargin { PropertyAnimation {duration:  50} }
            }
        }

        Component.onCompleted: loadSettings()
    }

    Item {
        id: preselectionBox
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 35

        function preselectionBoxClicked(value) {
            var newdate = new Date();

            if (value == 1) {
                console.debug("Today")
            }
            if (value == 2) {
                console.debug("Tomorrow")
                newdate.setDate(newdate.getDate()+1)
            }
            if (value == 3) {
                console.debug("add 1 Week")
                newdate.setDate(newdate.getDate()+7)
            }
            if (value == 4) {
                console.debug("add 1 Month")
                newdate.setMonth(newdate.getMonth()+1)
            }

            xaqmlDatePicker1.theMonth = newdate.getMonth()+1 //get current month (1-12)
            xaqmlDatePicker1.theYear = newdate.getFullYear() //get current year
            xaqmlDatePicker1.theDay = newdate.getDate() // get current date

            xaqmlDatePicker1.theTime = getClockTime()
            //timeInput.text = xaqmlDatePicker1.theTime
            xaTimePicker.setHours(theTime.substring(0,2))
            xaTimePicker.setMinutes(theTime.substring(3,5))

            if (xaqmlDatePicker1.enabled == false) {
                // enable date picker on preselection click
                onOffBox.setOn()
                xaqmlDatePicker1.enabled = true
            }

            loadSelectedMonth()

            dateSelected()
        }

        Rectangle {
            id: preselectionTodayRect
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.top: parent.top
            width: 100
            height: 22
            color: "black"
            border.color: "white"
            border.width: 1
            smooth: true
            radius: 3

            property color textColor: "white"

            Text {
                id: preselectionTodayLabel
                anchors.fill: parent
                color: parent.textColor
                text: "Today"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true
            }

            MouseArea {
                id: preselectionTodayMouseArea
                anchors.fill: parent

                onClicked: preselectionBox.preselectionBoxClicked(1)
                onPressed: { parent.color = "white"; parent.textColor = "black" }
                onReleased: { parent.color = "black"; parent.textColor = "white" }
            }
        }

        Rectangle {
            id: preselectionTomorrowRect
            anchors.right: parent.right
            anchors.rightMargin: 20
            anchors.top: parent.top
            width: 100
            height: 22
            color: "black"
            border.color: "white"
            border.width: 1
            smooth: true
            radius: 3

            property color textColor: "white"

            Text {
                id: preselectionTomorrowLabel
                anchors.fill: parent
                color: parent.textColor
                text: "Tomorrow"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true
            }

            MouseArea {
                id: preselectionTomorrowMouseArea
                anchors.fill: parent

                onClicked: preselectionBox.preselectionBoxClicked(2)
                onPressed: { parent.color = "white"; parent.textColor = "black" }
                onReleased: { parent.color = "black"; parent.textColor = "white" }
            }
        }

        Rectangle {
            id: preselection1WeekRect
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.top: parent.top
            anchors.topMargin: 25
            width: 100
            height: 22
            color: "black"
            border.color: "white"
            border.width: 1
            smooth: true
            radius: 3

            property color textColor: "white"

            Text {
                id: preselection1WeekLabel
                anchors.fill: parent
                color: parent.textColor
                text: "+1 Week"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true
            }

            MouseArea {
                id: preselection1WeekMouseArea
                anchors.fill: parent

                onClicked: preselectionBox.preselectionBoxClicked(3)
                onPressed: { parent.color = "white"; parent.textColor = "black" }
                onReleased: { parent.color = "black"; parent.textColor = "white" }
            }
        }

        Rectangle {
            id: preselection1MonthRect
            anchors.right: parent.right
            anchors.rightMargin: 20
            anchors.top: parent.top
            anchors.topMargin: 25
            width: 100
            height: 22
            color: "black"
            border.color: "white"
            border.width: 1
            smooth: true
            radius: 3

            property color textColor: "white"

            Text {
                id: preselection1MonthLabel
                anchors.fill: parent
                color: parent.textColor
                text: "+1 Month"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true
            }

            MouseArea {
                id: preselection1MonthMouseArea
                anchors.fill: parent

                onClicked: preselectionBox.preselectionBoxClicked(4)
                onPressed: { parent.color = "white"; parent.textColor = "black" }
                onReleased: { parent.color = "black"; parent.textColor = "white" }
            }
        }
    }

    Item {
        id: calendarBox
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        anchors.top: parent.top
        anchors.topMargin: 90
        anchors.bottom: parent.bottom
        height: 150
        //width: 150

        //
        // calendar header / month up and down boxes
        //

        Item {
            id: dateNavBox
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            height: 24
            anchors.leftMargin: 10; anchors.rightMargin: 10
            //color: "#000000"
            //opacity: 0.7

            Item {
                id: dateNavLeft
                anchors.left: parent.left
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavLeftImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarBackButton12px.png"
                }

                MouseArea {
                    id: dateNavLeftMouseArea
                    anchors.fill: parent

                    onClicked: {
                        if (theMonth > 1) theMonth--
                        else {
                            theYear--;
                            theMonth = 12;
                        }
                        console.debug("Month:" + theMonth + " Year:" + theYear)
                        loadSelectedMonth();
                    }
                }
            }

            Item {
                id: dateNavToday
                anchors.left: parent.left
                anchors.leftMargin: 14
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavTodayImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarTodayButton12px.png"
                }

                MouseArea {
                    id: dateNavTodayMouseArea
                    anchors.fill: parent

                    onClicked: loadNow();
                }
            }

            Item {
                id: dateNavRight
                anchors.left: parent.left
                anchors.leftMargin: 28
                y: 4
                width: 12
                height: 12

                Image {
                    id: dateNavRightImage
                    anchors.fill: parent
                    smooth: true

                    source: "pics/CalendarNextButton12px.png"
                }

                MouseArea {
                    id: dateNavRightMouseArea
                    anchors.fill: parent

                    onClicked: {
                        if (theMonth < 12) theMonth++
                        else {
                            theYear++;
                            theMonth = 1;
                        }
                        console.debug("Month:" + theMonth + " Year:" + theYear)
                        loadSelectedMonth();
                    }
                }
            }


            Text {
                id: dateNavLabel
                anchors.right: parent.right
                anchors.left: parent.left
                anchors.leftMargin: 40
                anchors.top: parent.top
                height: 20

                color: "white"
                text: currentMonth + " " + currentYear
                //font.family: "Helvetica"
                font.family: "Arial"
                //font.pointSize: 11
                font.pixelSize: 11
                font.bold: true
                horizontalAlignment: Text.AlignRight
                verticalAlignment: Text.AlignVCenter
            }
        }

        Rectangle {
            id: gridLine1
            anchors { left: parent.left; right: parent.right; rightMargin: 3; top: parent.top; topMargin:40 }
            height: 19
            color: "#ebebeb"
            radius: 8
        }

        Rectangle {
            id: gridLine2
            anchors { left: parent.left; right: parent.right; rightMargin: 3; top: parent.top; topMargin:60 }
            height: 19
            color: "#ebebeb"
            radius: 8
        }

        Rectangle {
            id: gridLine3
            anchors { left: parent.left; right: parent.right; rightMargin: 3; top: parent.top; topMargin:80 }
            height: 19
            color: "#ebebeb"
            radius: 8
        }
        Rectangle {
            id: gridLine4
            anchors { left: parent.left; right: parent.right; rightMargin: 3; top: parent.top; topMargin:100 }
            height: 19
            color: "#ebebeb"
            radius: 8
        }
        Rectangle {
            id: gridLine5
            anchors { left: parent.left; right: parent.right; rightMargin: 3; top: parent.top; topMargin:120 }
            height: 19
            color: "#ebebeb"
            radius: 8
        }

        Column {
            id: box; spacing: 8

            anchors { fill: parent; topMargin: 20; bottomMargin: 25; leftMargin: 6; rightMargin: 6 }


            Column {
                id: column; spacing: 2

                property real h: ((box.height) / 6) - ((spacing * (6 - 1)) / 6) -1
                property real w: (box.width / 4) - ((spacing * (4 - 1)) / 4)

                Grid {
                    id: grid; rows: 6; columns: 7; spacing: 1
                    anchors { fill: parent }

                    property real w: (box.width / columns) - ((spacing * (columns - 1)) / columns)

                    XAQMLDatePickerButton { id: xlwd1; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd2; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd3; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd4; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd5; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd6; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }
                    XAQMLDatePickerButton { id: xlwd7; width: grid.w; height: column.h; font.bold:true; enabled: false; textColor:"white" }

                    XAQMLDatePickerButton { id: xld01; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld02; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld03; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld04; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld05; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld06; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld07; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld11; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld12; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld13; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld14; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld15; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld16; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld17; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld21; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld22; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld23; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld24; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld25; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld26; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld27; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld31; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld32; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld33; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld34; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld35; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld36; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld37; width: grid.w; height: column.h; }

                    XAQMLDatePickerButton { id: xld41; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld42; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld43; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld44; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld45; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld46; width: grid.w; height: column.h; }
                    XAQMLDatePickerButton { id: xld47; width: grid.w; height: column.h; }
                }
            }
        }

    }

    function zeroPad(num,count) {
        var numZeropad = num + '';
        while(numZeropad.length < count) {
            numZeropad = "0" + numZeropad;
        }
        return numZeropad;
    }

    Rectangle {
        id: timePickerFrame
        anchors.top: parent.top
        anchors.topMargin: 250
        anchors.left: parent.left
        anchors.right: parent.right
        height: 114

        gradient: Gradient {
            GradientStop { position: 0; color: "#222222" }
            GradientStop { position: 0.5; color: "#3f3b3c" }
            GradientStop { position: 1; color: "#222222" }
        }

        XATimePicker {
            id: xaTimePicker
            anchors.top: parent.top
            anchors.topMargin: 5
            anchors.left: parent.left
            anchors.leftMargin: 65
            anchors.right: parent.right
            anchors.rightMargin: 65
            height: 110

            textColor: "black"
            fontSize: 24

            gradientBg: Gradient {
                GradientStop { position: 0; color: "gray" }
                GradientStop { position: 0.32; color: "white" }
                GradientStop { position: 0.68; color: "white" }
                GradientStop { position: 1; color: "gray" }
            }

            onHoursChanged: {
                theTime = zeroPad(xaTimePicker.getHours(), 2) + ":" + zeroPad(xaTimePicker.getMinutes(), 2) + ":00"
                dateSelected()
            }
            onMinutesChanged: {
                theTime = zeroPad(xaTimePicker.getHours(), 2) + ":" + zeroPad(xaTimePicker.getMinutes(), 2) + ":00"
                dateSelected()
            }
        }
    }



}
